// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

// Functions for clustering similar histograms together.

#ifndef PIK_CLUSTER_H_
#define PIK_CLUSTER_H_

#include <stdint.h>
#include <stdlib.h>
#include <algorithm>
#include <cmath>
#include <complex>
#include <cstdint>
#include <limits>
#include <map>
#include <memory>
#include <utility>
#include <vector>

namespace pik {

struct HistogramPair {
  int idx1;
  int idx2;
  float cost_combo;
  float cost_diff;
};

inline bool operator<(const HistogramPair& p1, const HistogramPair& p2) {
  if (p1.cost_diff != p2.cost_diff) {
    return p1.cost_diff > p2.cost_diff;
  }
  return std::abs(p1.idx1 - p1.idx2) > std::abs(p2.idx1 - p2.idx2);
}

/* ClusterCostDiff() removed */

/* CompareAndPushToQueue() removed */

/* HistogramCombine() removed */

// -----------------------------------------------------------------------------
// Histogram refinement

/* HistogramBitCostDistance() removed */

/* HistogramRemap() removed */

/* HistogramReindex() removed */

/* ClusterHistograms() removed */

}  // namespace pik

#endif  // PIK_CLUSTER_H_
