/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef path_h
#define path_h

#include <loa-buffer.h>

typedef struct{
    loa_point_t close;
    loa_point_t last;
    loa_point_t next;
}path_state_t;

double path_segment_length(const loa_segment_t*, const loa_point_t*, path_state_t*);
double path_length(const loa_path_t*, const loa_segment_t*, const loa_point_t*);
//void path_segment_rotate(const loa_segment_t*, const loa_point_t*, loa_point_t*, double *x, double *y, double *a);
void path_curve_trace(const loa_point_t*, const loa_point_t*, const loa_point_t*, const loa_point_t*, double frac, double *x, double *y, double *a);
void path_segment_trace(const loa_segment_t*, const loa_point_t*, path_state_t*, double frac, double *x, double *y, double *a);
void path_trace(const loa_path_t*, double, const loa_segment_t*, const loa_point_t*, double frac, double *x, double *y, double *a);
void path_start(const loa_path_t*, const loa_segment_t*, const loa_point_t*, double *x, double *y);

#endif /* path_h */
