/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef nil_atarist_h
#define nil_atarist_h

#include "nile.h"

typedef struct{
    uint8_t resolution[2];
    uint8_t screen[56784];
    uint8_t palette[32];
}nil_atarist_vram_t;

void nil_atarist_copy_colors(uint8_t *dst, int bpc, nile_format_t, const uint8_t *src, int count);
void nil_atarist_bitplanes_from_vram(nile_t*, int resolution, const uint8_t *screen, const uint8_t *palette);

#define nil_atarist_set_resolution(vram,r) {(vram)->resolution[0]=0;(vram)->resolution[1]=(r);}
int nil_atarist_vram_encode(nil_atarist_vram_t*, const nile_t*);

#endif /* nil_atarist_h */
